/*
 * Target		:	combobox	下拉列表框
 * Properties	:	[valueField,textField,onSelect,data]
 * Bug : 不加label控件不会执行onSelect，可能在某些应用场景有问题；
 */
$.fn.combobox = function(opts,parameter){
	var that = this;
	Embed.prototype.disabled = function(){
		$(that).attr("disabled",parameter) ;
		layui.form.render();
	},Embed.prototype.getValue = function(){
		return checkElement = that.next().find(".layui-this").attr("lay-value") || "";
	},Embed.prototype.getText = function(){
		return checkElement = that.next().find(".layui-this").text() || "";
	},Embed.prototype.select = function(){
		var next = that.next().find("[lay-value='"+parameter+"']").click();
		return next;
	},Embed.prototype.getData = function(){
		var layElement = that.next();
	},Embed.prototype.setData = function(){
		that.html("");
		opts = that[0]["config"];
		opts["data"] = parameter;
//		for(var i = 0 ; i < parameter.length ; i++ ) that.append('<option value="'+(parameter[i][key] || '')+'">'+(parameter[i][value] || "")+'</option>');
		this.init();
	},Embed.prototype.init = function(){
		that.next().length > 0 && that.next().remove(),that.children().remove();
		var data = opts.data || [];
		var key = (opts.valueField||"value"), value = (opts.textField||"text"), labelConcat = {};
		opts.label && (labelConcat[key] = "",labelConcat[value] = opts.label,data=[labelConcat].concat(data));
		for(var i = 0 ; i < that.length ; i++ ) that[i]["config"] = opts;
		for(var i = 0 ; i < data.length ; i++ ) that.append('<option placeholder="请选择..." value="'+(data[i][key] || '')+'">'+(data[i][value] || "")+'</option>');
		var form = null,layfilter = $.getUUID();
		(that.attr("lay-filter") && (layfilter = that.attr("lay-filter"))) || that.attr("lay-filter",layfilter) ;
		layui && layui.form && (form=layui.form);
		form && opts.onSelect && (
			form.on('select('+layfilter+')', function(data){
				var param = {};
				param[key] = data.value;
				param[value]= $(data.elem).find("option:selected").text();
				param["data"] = data;
				opts.onSelect(param);
			}) 
		)
		layui.form.render();
		return false;
	};
	var embed = new Embed();
	return opts in embed ? embed[opts]() : embed.init();
	function Embed(){}
}

$.fn.datagrid = function(opts,parameter){
	var that = this;
	Embed.prototype.init = function(){
		var id = that.attr("id") || that.attr("id",$.getUUID()).attr("id"),layfilter = $.getUUID();
		(that.attr("lay-filter") && (layfilter = that.attr("lay-filter"))) || that.attr("lay-filter",layfilter) ;
		layui && layui.table && render() ;
		!opts.data && (opts.data = []);
		for(var i = 0 ; i < that.length ; i++ ) that[i]["options"] = opts;
		function render(){
			var c_table = layui.table;
			opts["elem"] = "#" + id;
			c_table.render(opts);
			var onCheck = opts.onCheck || null,
				onUncheck = opts.onUncheck || null,
				onCheckAll = opts.onCheckAll || null,
				onUncheckAll = opts.onUncheckAll || null;
			c_table.on('checkbox('+layfilter+')', function(obj){
				if(obj.type == "one"){
					if(obj.checked){
						onCheck && onCheck(obj);
					}else{
						onUncheck && onUncheck(obj);
					}
				}else{
					if(obj.checked){
						onCheckAll && onCheckAll(obj);
					}else{
						onUncheckAll && onUncheckAll(obj);
					}
				}
			});
			if(opts.sort){
				c_table.on('sort('+layfilter+')', opts.sort);
			}
//			$(".layui-form-checkbox").click(function(){
//				var obj = $(this);
//				if($(this).attr("ck") == "ck"){
//					onUncheck && onUncheck(obj);
//					$(this).removeAttr("ck");
//				}else{
//					onClick && onClick(obj);
//					$(this).attr("ck","ck");
//				}
//			})
		}
		opts.onLoadSuccess && opts.onLoadSuccess();
		return true;
	},Embed.prototype.check = function(){
		if(typeof(parameter) === "object"){
			var col = parameter.col,
				value = parameter.value,
				check = "check" in parameter ? parameter.check : true,
				callback = parameter.callback || null;
			var data_fields = that.next().find('.laytable-cell-1-'+col);
			for(var i = 0 ; i < data_fields.length ; i++ ){
				var c_field = $(data_fields[i]);
				if(c_field.html() == value){
					var trEle = c_field.closest("tr");
					check && trEle.find(".layui-form-checkbox").trigger("click");
					callback && callback(trEle);
					return trEle.attr("data-index");
				}
			}
			return -1;
		}
	},Embed.prototype.getChecked = function(){
		var checks = that.next().find(".layui-table-main .layui-form-checked").closest("tr"),
			data = layui.table.cache.datagrid || that[0].options.data,
			result = [];
		for(var i = 0 ; i < checks.length ; i++ ){
			var dataIndex = $(checks[i]).attr("data-index"); 
			var tempMap = data[dataIndex];
			tempMap["LAY_TABLE_INDEX"] = dataIndex;
			result.push(tempMap);
		}
		return result;
	},Embed.prototype.getData = function(){
		return that[0].options.data;
	}
	/*
	 * 这里在chrome上面，本来table宽度是100%，appendRow之后会导致table宽度变小了。
	 * 经过查看源码与调试分析后发现，谷歌初始化的时候，table的width未生效，appendRow相当于删除之前的div.table，新增后宽度设置auto生效，导致宽度变小。
	 * 理论上这属于浏览器问题。具体判断方法是将proto的table与衍生的div位置进行互换调整即可发现此问题。
	 */
	,Embed.prototype.appendRow = function(){
		var data = that[0].options.data;
		data = data && Array.isArray(data) ? data.concat([parameter]) : [parameter];
		that[0].options.data = data;
		layui.table.reload(that.attr("id"),{data : data});
		layui.table.render(that[0].options);
		that[0].options.onLoadSuccess && that[0].options.onLoadSuccess();
	},Embed.prototype.setData = function(){
		that[0].options.data = parameter;
		layui.table.reload(that.attr("id"),{data : parameter});
		that[0].options.onLoadSuccess && that[0].options.onLoadSuccess();
	},Embed.prototype.getData = function(){
		return that[0].options.data;			
	},Embed.prototype.reload = function(){
		layui.table.reload(that.attr("id"));			
	};
//	$("#conditionGrid")[0].options
	var embed = new Embed();
	return opts in embed ? embed[opts]() : embed.init();
	function Embed(){}
}

$.getUUID = function(){
	var s = [];
	var hexDigits = "0123456789abcdef";
	for (var i = 0; i < 32; i++) {
	s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
	}
	s[14] = "4"; // bits 12-15 of the time_hi_and_version field to 0010
	s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01
//	s[8] = s[13] = s[18] = s[23] = "-";
	var uuid = s.join("").toUpperCase();
	return uuid;
} 
