

/* ################################################################################################ */
var Model = function () {
    var me = this;
    this.chacheModule = {};
    this.currDirInfo = {};
    this.currBusCode = decodeURIComponent(globalutil.GetQueryString('buscode'));
    this.maincode = decodeURIComponent(globalutil.GetQueryString('code'));

    this.urlArr = {};

    this.getYWAffixServ = config["url"]["phone-getYWLBAffix"];                                  // 获取已经配置好的附件材料目录（新增时）
    this.getBeingEditAffixDataUrl = config["url"]["phone-getUploadedAffixData"]; // 获取已经上传到数据库中的数据（编辑时）

    this.saveAttachPictureUrl = config["url"]["phone-saveAttachPicture"]; // 保存附件材料
    this.delUploadedAffixUtl = config["url"]["phone-delUploadedAffix"];                  // 删除已上传的附件材料文件

    this.getPhoneScanFlagUrl = config["url"]["phone-checkPhoneScanFlag"]; // 判断可否上传

    /* 关闭浏览器 */
    this.closeHTML = function () {
        window.opener = null;
        window.open('', '_self');
        window.close();
    }
}

/* ################################################################################################ */
var Service = function (model) {
    var me = this;

    // 获取流程配置的附件材料目录(新增)
    this.getAffixList = function () {
    	com.ajax({
    		url : model.getYWAffixServ,
    		data : { "YWLB": model.currBusCode },
    		type : "post",
    		dataType : "json",
    		async : false,
    		cache : false,
    		success : function(data){
    			model.affixList = data.rows;
                if (com.isEmptyObject(model.affixList)) {
                    model.hasAffixConfig = false;
                } else {
                    model.hasAffixConfig = true;
                }
    		}
    	})
    }

    // 获取已经上传到数据库中的数据(编辑)
    this.getBeingEditAffixList = function () {
    	com.ajax({
    		url : model.getBeingEditAffixDataUrl,
    		data : { code: model.maincode, isOnlyGetDir: false },
    		type : "post",
    		dataType : "json",
    		async : false,
    		cache : false,
    		success : function(data){
    			var getAffixListByBuss = false;
                if (com.isEmptyObject(data.data)) {
                    getAffixListByBuss = true;
                } else {
                    model.hasAffixConfig = true;
                    model.initAffixList = data.data;
                    model.affixList = model.initAffixList.affixDirList;     //附件目录
                    // 若并未缓存附件目录, 则获取流程配置的附件目录
                    if (com.isEmptyObject(model.affixList)) {
                        getAffixListByBuss = true;
                    }
                    me.handleUploadedAffixFileList(model.initAffixList.affixFileList);    // 处理附件材料信息
                }
                if (getAffixListByBuss) {
                    me.getAffixList();
                }
    		}
    	})
    }
    // 处理已经上传的附件材料
    this.handleUploadedAffixFileList = function (data) {
        if (!com.isEmptyObject(data)) {
            model.urlArr = model.urlArr || {};
            com.each(data, function (i, item) {
                model.urlArr[item.ACID] = model.urlArr[item.ACID] || {};
                model.urlArr[item.ACID][item.savename] = item;
            })
        }
    }

    // delete uploaded affix
    this.delUploadedAffix = function (code, url) {
    	com.ajax({
    		url : model.delUploadedAffixUtl,
    		data : { affixID: code, affixURL: url },
    		type : "post",
    		dataType : "json",
    		async : false,
    		cache : false,
    		success : function(data){
    		}
    	})
    }

    // 
    this.checkPhoneScanFlag = function () {
    	com.ajax({
    		url : model.getPhoneScanFlagUrl,
    		data : { code: model.maincode },
    		type : "post",
    		dataType : "json",
    		async : false,
    		cache : false,
    		success : function(data){
    			var data = data.data
	                , bl = data.BL
	                , flag = data.flag
	                , msg = '';
//	            if (flag == 0) {
//	                msg = '电脑端已终止手机扫描功能，不可进行手机端操作！'
//	            }
	//            else if (flag == 2) {
	//                msg = '不可多人同时进行手机端操作！'
	//            }
	            if (msg != null && msg != '') {
	                model.canphoneupload = false;
	                layui.layer.alert(msg, function () {
	                    model.closeHTML();
	                });
	            } else {
	                model.canphoneupload = true;
	            }
	            console.log(model);
    		}
    	})
    }
}

/* ################################################################################################ */
var Controller = function () {
    var me = this
        , model = new Model()
        , service = new Service(model)

    this.init = function () {
        service.checkPhoneScanFlag();
        console.log(model);
        if (model.canphoneupload) {
            service.getBeingEditAffixList();

            // 渲染界面 初始化上传控件
            model.affixItemClone = com('#affixItemTemplate').clone(true).attr('id', '').show();    // 附件目录模板
            model.affixUploadClone = com('#templateUpload').clone(true).attr('id', '').show();    // 附件目录模板
            me.renderAffixList();
            me.initUploadControl();
        }
    }
    // 渲染上传附件目录列表
    this.renderAffixList = function () {
        var affHtml = []
            , tempclone = null
            , tempHtml = '';
        model.chacheModule = model.chacheModule || {};
        model.urlArr = model.urlArr || {};
        if (model.hasAffixConfig) {
        	com.each(model.affixList, function (i, item) {
                var uuid = globalutil.guid();
                model.chacheModule[uuid] = item;
                // 上传附件张数
                var fileList = model.urlArr[item.AC_ID] || {}
                    , fileListLen = Object.keys(fileList).length;

                // 获取模板 
                tempclone = model.affixItemClone.clone(true).attr('data_v', uuid).attr('data_t', item.CLMC);
                (item.SFBX == 1) && (tempclone.find('.affix-clmc').append('<b class="flag">*</b>'));  // 若是必须上传的，增加必填标识 *
                tempclone.find('.already-upload').html(fileListLen + '张');

                // 目录名称 
                tempHtml = tempclone.html().replace(/#affixname#/g, item.CLMC);
                com('#affixItemList').append(tempclone.html(tempHtml));
            })
        }
    }

    // 初始化上传控件
    this.initUploadControl = function () {
        model.files = model.files || {};
        model.urlArr = model.urlArr || {};
        if (typeof layui != 'undefined') {
            layui.use(['upload', 'layer'], function () {
                var upload = layui.upload;
                var demoListView = com('#fileList')
                model.uploadListIns = upload.render({
                    elem: '#filePicker'			          /* 上传按钮 */
                    , url: model.saveAttachPictureUrl     /* 图片保存action */
                    , data: {
                        UUID: decodeURIComponent(model.maincode)
                    }
//                	, contentType : "false"
                    , number: 10
                    , accept: 'images'
                    , multiple: true		              /* 是否可多传 */
                    , auto: false		                  /* 是否可自动上传 */
                    , bindAction: '#toUpBtn'              /* 开始上传按钮 */
                    , bindActionCheck: function () {      /* 点击上传按钮之前的检查操作 */
                        var flag = me.isEnbledUploadBtn();
                        if (flag) {
                            service.checkPhoneScanFlag();
                            flag = model.canphoneupload;
                        }
                        if (flag) {
                            var len = Object.keys(model.files).length;
                            flag = (len > 0);
                        }
                        return flag;
                    }
                    , before: function (obj) {
                        layer.load();
                        model.uploadListIns.config.data.fjmlid = decodeURIComponent(model.currDirInfo.AC_ID);
                    }
                    , choose: function (obj) {   	        /* 选择文件的回调 */
                        me.enableUploadBtn();
                        model.files = obj.pushFile(); //将每次选择的文件追加到文件队列
                        //读取本地文件
                        obj.preview(function (index, file, result) {
                            var thumb = me.renderAffixThumb(index, file, model.currDirInfo.CLMC, result)
                                , tr = me.uploadItem(thumb, index, true);

                            //单个重传
                            tr.find('.demo-reload').on('click', function () {
                                obj.upload(index, file);
                            });

                            //删除
                            tr.find('.demo-delete').on('click', function () {
                                var item = com(this);
                                me.deleteAffix(item, index);
                            });

                            demoListView.append(tr);
                        });
                    }
                    , done: function (res, index, upload) {
                        if (res.data.code == 0) {
                            var tr = demoListView.find('tr#upload-' + index)
                                , tds = tr.children();
                            tds.eq(1).html('<span style="color: #5FB878;">上传成功</span>');
                            tds.find('.demo-reload').remove().next('.demo-delete').attr('data_f', 'uploaded');

                            // 上传成功的文件
                            model.urlArr[model.currDirInfo.AC_ID] = model.urlArr[model.currDirInfo.AC_ID] || {};
                            model.urlArr[model.currDirInfo.AC_ID][index] = {
                                saveurl: res.data.src
                                , savename: res.data.affixName.split('.')[0]
                                , suffix: res.data.affixName.split('.').pop()
                                , oldname: res.data.affixName
                                , acid: model.currDirInfo.AC_ID
                                , pid: model.currDirInfo.AC_ID
                            };

                            return delete model.files[index]; //删除文件队列已经上传成功的文件  
                        }
                        this.error(index, upload);
                    }
                    , error: function (index, upload) {
                        layer.closeAll('loading'); //关闭loading
                        var tr = demoListView.find('tr#upload-' + index)
                            , tds = tr.children();
                        tds.eq(1).html('<span style="color: #FF5722;">上传失败</span>');
                        tds.eq(2).find('.demo-reload').removeClass('layui-hide'); //显示重传
                    }
                    , allDone: function (obj) { // 当文件全部被提交后，才触发  
                        layer.closeAll('loading');
                        me.diabledUploadBtn();
                    }
                }); /* upload End */
                com("input.layui-upload-file").attr("capture","camera").attr("accept","image/*")
            })
        }
    }

    /** 上传项目 */
    this.uploadItem = function (thumb, index, isnew) {
        var tr = com(['<tr id="upload-' + index + '">'
            , '<td>' + thumb + '</td>'
            // , '<td>' + (file.size / 1014).toFixed(1) + 'kb</td>'
            , isnew ? '<td>等待上传</td>' : '<td><span style="color: #5FB878;">上传成功</span></td>'
            , '<td>'
            , isnew ? '<button class="layui-btn layui-btn-mini layui-btn-fluid demo-reload layui-hide">重传</button>' : ''
            , '<button class="layui-btn layui-btn-mini layui-btn-danger layui-btn-fluid demo-delete" ' + (isnew ? '' : 'data_f="uploaded"') + '>删除</button>'
            , '</td>'
            , '</tr>'].join(''));
        return tr;
    }

    /** 缩略图渲染 */
    this.renderAffixThumb = function (index, file, cur_type, result) {
    	//将路径中所有的反斜杠\转换为正斜杠/(不然图片显示不出来)
        result = result.replace(/\\/g,"/");
        var suffix = file.name.split('.').pop()
            , img_html = [
                '<div class="d-inline-block preview prevImg mobilePre" data_name="' + file.name + '" data_suffix="' + suffix + '"', ' >',
                '<img class="layui-upload-img" src="' + encodeURI(result) + '" alt="' + cur_type + '材料' + index + '" id="' + index + '">',
                '</div>'
            ].join('');
        return img_html;
    }

    /** 删除附件材料 */
    this.deleteAffix = function (item, index) {
        var scanflag = true;
        service.checkPhoneScanFlag();
        scanflag = model.canphoneupload;
        if (scanflag) {
            var flag = item.attr('data_f')
                , tr = item.parents('tr');
            delete model.files[index];
            tr.remove();
            model.uploadListIns.config.elem.next()[0].value = ''; //清空 input file 值，以免删除后出现同名文件不可选

            if (Object.keys(model.files).length <= 0) {
                me.diabledUploadBtn();
            }

            if (flag == 'uploaded') {
                var delid = model.urlArr[model.currDirInfo.AC_ID][index].SAVENAME
                    , delsrc = model.urlArr[model.currDirInfo.AC_ID][index].SAVEURL;
                service.delUploadedAffix(delid, delsrc);
                delete model.urlArr[model.currDirInfo.AC_ID][index];
            }
        }
    }

    // 启用 禁用上传按钮
    this.enableUploadBtn = function () {
    	com('#toUpBtn').removeClass('layui-btn-disabled');
    }
    this.diabledUploadBtn = function () {
    	com('#toUpBtn').addClass('layui-btn-disabled');
    }
    this.isEnbledUploadBtn = function () {
        var flag = com('#toUpBtn').hasClass('layui-btn-disabled')
        return !flag;
    }

    // 显示上传界面
    this.showUploadWrap = function (uuid) {
        var acinfo = model.chacheModule[uuid];
        if (acinfo != null) {
            model.currUUID = uuid;
            model.currDirInfo = acinfo;
            com('#affixItemList').hide();
            com('#affixFileList').show().find('.layui-table tbody').html('');
            me.diabledUploadBtn();
            // 显示已经上传过的文件
            me.renderUploadedList();
        }
    }

    // 显示已经上传过的文件
    this.renderUploadedList = function () {
        var fileList = model.urlArr[model.currDirInfo.AC_ID];
        if (fileList != null && Object.keys(fileList).length) {
        	com.each(fileList, function (key, fileobj) {
                var file = { name: fileobj.OLDNAME + '.' + fileobj.SUFFIX }
                    , thumb = me.renderAffixThumb(key, file, model.currDirInfo.CLMC, window.location.origin + config.prefix +"/affixManager/download?path=" + fileobj.SAVEURL)
                    , tr = me.uploadItem(thumb, key, false);
                //删除
                tr.find('.demo-delete').on('click', function () {
                    var item = com(this);
                    me.deleteAffix(item, key);
                });
                com('#fileList').append(tr);
            })
        }
    }

    // 返回列表界面
    this.showAffixListWrap = function () {
    	com('#affixItemList').show();
    	com('#affixFileList').hide();
        me.renderUploadedCount();
        model.currDirInfo = {};
        model.currUUID = '';
        // 清空文件列表
        com.each(model.files, function (key, file) {
            delete model.files[key];
        })
    }
    /** 已上传成功图片的数量 */
    this.renderUploadedCount = function (item) {
        var fileList = model.urlArr[model.currDirInfo.AC_ID];
        if (fileList != null) {
            var len = Object.keys(fileList).length
                , listitem = com('li.affix-item[data_v=' + model.currUUID + ']');
            listitem.find('.already-upload').html(len + '张');
        }
    }

}

/* #################################################################################################### */
com(function () {
    if (typeof layui == 'undefined') {
    	layui.layer.alert('该浏览器版本不支持layui上传组件，请使用微信/QQ浏览器/支付宝进行扫描上传操作！');
    } 
    
    var controller = new Controller();
    controller.init();

    // 点击一项
    com('#affixList').on('click', '.affix-item', function () {
        var uuid = com(this).attr('data_v');
        controller.showUploadWrap(uuid);
    })

    // 返回列表界面
    com('body').on('click', '#closeUpBtn', function () {
        controller.showAffixListWrap();
    })

    // 
    com('body').on('error', '.layui-upload-img', function (e) {
        var img = e.srcElement;
        img.src = kq.path.shell + 'images/404.png';
        img.onerror = null; // 控制不要一直跳动
    })
})

