layui.use([ 'form', 'element', 'table','laydate' ], function() {
	var form = layui.form;
	var element = layui.element;
	var table = layui.table;
	var checkedData;
	globalutil.render(".jdcx-search");
	queryCheckedList();	
	getLoginUser();
	
	// 获取配置的结果显示字段
	function queryCheckedList(){
		com.ajax({
			url : config["url"]["select-queryCheckedList-jdcx"], //获取已配置字段数据
			type : "POST",
			dataType : "JSON",	
			success : function(rst){
				if(rst.code == 200){
					if(com.isEmptyObject(rst) || com.isEmptyObject(rst.data) ){ 
						checkedData = initDefaultFiled();
					}else{
						checkedData = rst.data;
					}
				}else{
					checkedData = initDefaultFiled();
				}
			}
		})
	};
	
	function initDefaultFiled(){
		return [
			{SJZDMC: "业务编号", SJZDBM: "SLID"}
			, {SJZDMC: "申请人", SJZDBM: "SQR"}
			, {SJZDMC: "不动产单元号", SJZDBM: "BDCDYH"}
			, {SJZDMC: "宗地坐落", SJZDBM: "ZDZL"}
			, {SJZDMC: "当前环节", SJZDBM: "DQBLHJ"}
		];
	};
	
	form.on('submit(jdcx-submit)', function (data) {
		var formData = data.field;
		console.log(formData);
		openShowDetail(formData);
		return false;
	});
	
	function getLoginUser(){
		com.ajax({
			url : config["url"]["header-info"],
			type : "POST",
			dataType : "JSON",
			success : function(rst){
				if(rst.code == 200){
					form.val('jdcx-search', {
						"USER_NAME": rst.data.username,
						"ZJHM": rst.data.idcard,
						"ZJLX": rst.data.idcardtype
					});
				}
			}
		})
	}
	
	function openShowDetail(data){
		com.ajax({
			url : config["url"]["select-queryJDCX"],
			type : "POST",
			dataType : "json",
			data : {
				QLRMC : data.USER_NAME,
				ZJHM : data.ZJHM,
				YWH : data.SLID
			},
			success : function(data){
				if (data.code == 200) {
					var rt = data.data;
					if (com.isEmptyObject(rt)) {
						layui.layer.alert("检查无此记录，请检查查询条件！");

						var html = '<tr><td style="padding: 15px 0; border: 1px solid #ddd;">检查无此记录！</td></tr>'; 	// 检查无此记录！
						com(".resultNone").html("").show().append(html);
						com(".resultTbody").hide();

					} else {
						//遍历配置字段
						var html = '';
						com(".resultTbody").html("");
						com.each(checkedData, function (idx, item) {
							/*if(item.SJZDBM=="SQR"){
								item.SJZDBM="SJR";
							}*/
							html += '<tr>';
							html += '<td class="showText">' + item.SJZDMC + '</td>';
							var zdValue = '';
							com.each(rt[0], function (idt, ite) {
								if (idt.toUpperCase() == item.SJZDBM) {
									zdValue = ite == null ? "" : ite;
									if (item.SJZDBM == 'SFSL') {
										switch (zdValue) {
											case 0: zdValue = '未受理'; break;		// 未受理
											case 1: zdValue = '已受理'; break;		// 已受理
											default: zdValue = '其它';				//其它
										}
									}else if (item.SJZDBM == 'GDSTATE') {
										switch (zdValue) {
											case 0: zdValue = '未归档'; break;		// 未归档
											case 1: zdValue = '已归档'; break;		// 已归档
											default: zdValue = '其它';				//其它
										}
									}
								}
							})
							html += '<td class="showValue">' + zdValue + '</td>';
							html += '</tr>';
						})
						com(".resultTbody").append(html);
						com(".resultTbody").show();
						com(".jdcx-search").hide();
					}

				} else {
					if (com.isEmptyObject(data.data)) {
						layui.layer.alert(data.msg);	// 服务器开小差了，请稍后重试
					} else {
						layui.layer.alert(data.data.EX);
					}
					return false;
				}
			}
		})
	};
	
//	layui.form.render();
})