layui.use([ 'form', 'element', 'table' ], function() {
	var form = layui.form;
	var element = layui.element;
	var REC_ID = globalutil.GetQueryString("ID");
	var users_qlr = new UserInfo({
		title : '权利人（买方）信息',
		itemid : "qlr",
		isCanAddUser : true
	});
	var users_ywr = new UserInfo({
		title : '义务人（卖方）信息',
		itemtype : "ywr",
		isCanAddUser : false
	});
	function init(){
		users_qlr.addUserItem({isCanDelete : false});
		users_ywr.addUserItem({isCanDelete : false});
	}

	//根据数据初始化界面
	function initData(data){
		for(var i = 0 ; i < data.length ; i++){
			var tmp = data[i];
			//区分权利人、义务人，并渲染模板
			if(tmp.BZ == "0"){
				tmp["isCanDelete"] = (i == 0 ? false : true);
				tmp["disabled"] = {
					GYFS : tmp.GYFS != '0' ?　'0' : ''
				};
				users_qlr.addUserItem(tmp);
			}else{
				tmp["isCanDelete"] = false;
				tmp["disabled"] = {
					QLRMC : "true",
					ZJLX : "true",
					ZJHM : "true",
					QLRLX : "true",
					XB : "true",
					GYFS : "0||1||2",
					QLBL : "true"
				};
				users_ywr.addUserItem(tmp);
			}
		}
		//义务人不可能为空，因为是从不动产拿过来的，如果是空就是错误数据
		//如果权利人为空，自动加载一个模板
		if(users_qlr.getSize() == 0){
			users_qlr.addUserItem({isCanDelete : false,BZ : '0'});
		}
		//信息采集的权利人数据包装
		bdccollection["userinfo"] = function(){
			var qlrList = users_qlr.getDataList(REC_ID),
				ywrList = users_ywr.getDataList(REC_ID);
			var flag = true;
			//权利人不可为空，前面已经自动加载一个模板了，并且这个模板是不可删除的
			if(qlrList.length == 0){
				layui.layer.alert("系统错误，权利人列表不可为空");
				return false;
			}if(qlrList.length == 1 && qlrList[0].gyfs != "0"){	//如果共有情况不是单独所有
				users_qlr.scrollOn();
				layui.layer.msg("当前仅有一条权利人信息，请选择单独所有方式", { icon: 5, shift: 6 }, function () {
//					        $('.focus').removeClass('focus');
				});
				return false;
			}else if(qlrList.length > 1){	//如果权利人信息是多条，去判断共有情况和权利比例
				if(qlrList[0].gyfs == "2"){
					var total = 0;
					com.each(qlrList,function(key,tmp){
						if(com.trim(tmp.qlbl) == ""){
							users_qlr.scrollOn();
							layui.layer.msg(tmp.qlrmc + "的所占份额不可为空", { icon: 5, shift: 6 });
							flag = false;
						}else{
							total += parseInt(com.trim(tmp.qlbl));
						}
					})
					if(!flag) return false;
					if(total != 100){
						users_qlr.scrollOn();
						layui.layer.msg("按份共有占有份额总值应为100%", { icon: 5, shift: 6 });
						return false;
					}
				}
			}
			return {
				qlrList : JSON2.stringify(qlrList.concat(ywrList)),
				qlrDelList : JSON2.stringify(users_qlr.getDelList())
			}
		}
		if("showdetail" in window || ("process" in window && process.getIndex() != "3")){
    		com(".block-users").find("*").not("button.block-userInfo-media,button.block-userInfo-picture").attr("disabled","disabled");
    		com(".block-users").find(".userTemplateDelete").remove();
    		com(".block-users").find(".block-userInfo-adduser").remove();
    		com(".block-users").find(".block-userInfo-gyqk").find("lay-radio").off("click");
    		layui.form.render();
    	}
	}
		//初始化
		if(REC_ID){
			com.ajax({
				url : config["url"]["process-getUserDataListByID"],
				type : "POST",
				contentType: "application/json;charset=UTF-8",
				dataType : "JSON",
				data : JSON.stringify({
					ID : REC_ID
				}),
				load : true,
				success : function(rst){
					if(rst.code == "200"){
						initData(rst.data);
					}else{
						layui.layer.alert(rst.msg);
					}
				}
			})
		}else{
			init();
		}
	}
)